import React from "react";
import { useFuse } from "./hooks/useFuse";
import { FuzzyInputProvider } from "./hooks/useFuzzyInput";
import { FuzzyResultProvider } from "./hooks/useFuzzyResult";
import FuzzyGui from "./FuzzyGui";
// fuse specific default option
var optionsDefault = {
    //includeMatches: true,
    ignoreLocation: true,
    ignoreFieldNorm: false,
    includeScore: true,
    keys: ["txt"],
};
//default options for mark.js
var markOptionsDefault = {
    element: "b",
    accuracy: "complementary",
    exclude: ["h5"],
};
var ZIMFuzzySearch = function (_a) {
    var data = _a.data, onSelect = _a.onSelect, searchInput = _a.searchInput, setSearchInput = _a.setSearchInput, _b = _a.fuseOptions, fuseOptions = _b === void 0 ? optionsDefault : _b, _c = _a.markOptions, markOptions = _c === void 0 ? markOptionsDefault : _c, _d = _a.resultCountLabel, resultCountLabel = _d === void 0 ? "Matches: " : _d, children = _a.children;
    var _e = useFuse(data, fuseOptions), fuseResult = _e.fuseResult, doFuseSearch = _e.doFuseSearch, groupBy = _e.groupBy;
    var _f = React.useState(searchInput ? searchInput : ""), inputVal = _f[0], setInputVal = _f[1];
    // two way binding
    React.useEffect(function () {
        if (!searchInput)
            return;
        setInputVal(searchInput);
    }, [searchInput]);
    // when input change do search
    React.useEffect(function () {
        doFuseSearch(inputVal);
    }, [inputVal]);
    var handleInput = function (val) {
        setInputVal(val);
        // ensure two way binding
        if (setSearchInput)
            setSearchInput(val);
    };
    return (React.createElement(FuzzyInputProvider, { handleInput: handleInput, inputVal: inputVal },
        React.createElement(FuzzyResultProvider, { fuzzyResult: fuseResult && Object.keys(fuseResult).length !== 0 ? fuseResult : null, onSelect: onSelect, resultCountLabel: resultCountLabel }, children ? children : React.createElement(FuzzyGui, { markOptions: markOptions }))));
};
export default ZIMFuzzySearch;
